# -*- coding:Utf-8 -*-

import es
import gamethread
import msglib
import langlib
import playerlib
import os
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "redirectlib"
info.version = "1.0"
info.author = "EmbouT"
info.url = "http://mattie.info/forums/"
info.description = "Fourni une méthode pour rediriger un joueur sur un autre serveur. Mot de passe pris en charge"


### GLOBAL VARIABLE ###

# Temps d'affichage par défaut d'une proposition de redirection (peut être décimal)
defaut_delai = 15
# Action par défaut si le joueur n'accepte pas la proposition dans le temps imparti 0= non kické / 1 = kické (conseillé)
defaut_kick = 1

### CLASS ###

class Redirect(object):
    def __init__(self,ip,password='',kick=1,delai=float(defaut_delai)):
        if str(delai)=='':delai=float(default_delai)
        if str(kick)=='':kick=defaut_kick
        try:
            self.time=float(delai)
            if not int(self.time):self.time =float(defaut_delai)
        except ValueError:
            es.dbgmsg(0,'[redirectlib] delai (%s) doit être un nombre'%delai)
            es.dbgmsg(0,'[redirectlib] delai est défini à la valeur par défaut : %s'%defaut_delai)
            self.time = float(defaut_delai)
        try:
            self.kick=int(kick)
        except ValueError:
            es.dbgmsg(0,'[redirectlib] kick (%s) doit être 1 ou 0'%kick)
            es.dbgmsg(0,'[redirectlib] kick est défini à la valeur par défaut : %s'%defaut_kick)
            self.kick=defaut_kick
        if not str(password)=='':
            self.server=str(ip)+';password '+str(password)
        else :
            self.server = str(ip)


    def send(self,userid):
        if userid:
            if not es.exists('userid', userid):
                es.dbgmsg(0,"[redirectlib] %s n'est pas un userid valide !"%userid)
            else :
                msglib.VguiDialog(title=self.server, time=self.time, mode=msglib.VguiMode.ASKCONNECT).send(userid)
                if self.kick:
                    gamethread.delayedname(self.time,'redirectlibkick%s'%userid,kickplayer,(self.server,userid))

def kickplayer(ip,userid):
    es.server.queuecmd('kickid %s "Merci de taper \'connect %s\' dans votre console"'%(userid,ip))


def player_disconnect(event_var):
    gamethread.cancelDelayed('redirectlibkick%s'%event_var['userid'])



